{-
Repraesentation eines Sets als Baum
-}

module SetByTree (TSet, empty, isEmpty, member, insert, delete)
where
  data TSet a = Null | 
                Fork (TSet a) a (TSet a)
  --leere Menge
  empty :: TSet a
  empty = Null
  
  --Test auf leere Menge
  isEmpty :: TSet a -> Bool
  isEmpty Null           = True
  isEmpty (Fork xt y zt) = False  
  
  --Test, ob Element in Menge ist
  member :: (Ord a) => TSet a -> a -> Bool
  member Null x = False
  member (Fork xt y zt) x
    |(x < y)  = member xt x
    |(x == y) = True
    |(x > y)  = member zt x
  
  --Einfuegen eines Elements in eine Menge
  insert :: (Ord a) => a -> TSet a -> TSet a
  insert x Null = (Fork Null x Null)
  insert x (Fork xt y zt)
    |(x < y)  = Fork (insert x xt) y zt
    |(x == y) = Fork xt y zt
    |(x > y)  = Fork xt y (insert x zt)
  
  --loeschen eines Elements aus einer Menge
  delete :: (Ord a) => a -> TSet a -> TSet a
  delete x Null = Null
  delete x (Fork xt y zt)
    |(x < y)  = Fork (delete x xt) y zt
    |(x == y) = join xt zt
    |(x > y)  = Fork xt y (delete x zt)
  
  
  --Hilfsfunktionen
  join :: TSet a -> TSet a -> TSet a
  join xt yt = if isEmpty yt then xt
               else Fork xt y zt
               where
                 (y,zt) = splitTree yt
    
  splitTree :: TSet a -> (a, TSet a)
  splitTree (Fork xt y zt) = if isEmpty xt then (y, zt)
                             else (u, Fork vt y zt)
                             where
                               (u, vt) = splitTree xt   


  abstr :: (Ord a) => [a] -> TSet a
  abstr = foldr insert empty
  
  reprn :: TSet a -> [a]
  reprn Null = []
  reprn (Fork xt y zt) = reprn xt ++ [y] ++ reprn zt
  
  instance Show a => Show (TSet a)
    where
    show Null         =  "-"
    show (Fork l a r) =  "(Fork "
                    ++ show l ++ " " 
                    ++ show a ++ " " 
                    ++ show r ++ ")"
     
  {-
  instance Show a => Show (TSet a)
    where
    show Null = "{}"
    show tree = '{':show' tree ++ "}"
      where
      show' Null = ""
      show' (Fork xt y zt) = show' xt ++ show y ++ " " ++ show' zt -}   